class NetworkStabilityModel {
  final String timeFrame;
  final List<BankData> banks;

  NetworkStabilityModel({
    required this.timeFrame,
    required this.banks,
  });

  factory NetworkStabilityModel.fromJson(Map<String, dynamic> json) =>
      NetworkStabilityModel(
        timeFrame: json["time_frame"],
        banks:
            List<BankData>.from(json["banks"].map((x) => BankData.fromJson(x))),
      );

  Map<String, dynamic> toJson() => {
        "time_frame": timeFrame,
        "banks": List<dynamic>.from(banks.map((x) => x.toJson())),
      };
}

class BankData {
  final String bank;
  final List<BrandElement> brands;

  BankData({
    required this.bank,
    required this.brands,
  });

  factory BankData.fromJson(Map<String, dynamic> json) => BankData(
        bank: json["bank"],
        brands: List<BrandElement>.from(
            json["brands"].map((x) => BrandElement.fromJson(x))),
      );

  Map<String, dynamic> toJson() => {
        "bank": bank,
        "brands": List<dynamic>.from(brands.map((x) => x.toJson())),
      };
}

class BrandElement {
  final String brand;
  final num percentage;

  BrandElement({
    required this.brand,
    required this.percentage,
  });

  factory BrandElement.fromJson(Map<String, dynamic> json) => BrandElement(
        brand: json["brand"],
        percentage: json["percentage_stability_range"],
      );

  Map<String, dynamic> toJson() => {
        "brand": brand,
        "percentage_stability_range": percentage,
      };
}
