class RavenMPosConst {
  static const locationStatus = "LocationStatus";
  static const onAlert = "ON_ALERT_CALLBACK";
  static const onError = "ON_ERRR_CALLBACK";
  static const scanForMPosDevice = "SCAN_FOR_MPOS_DEVICE";
  static const onBluetoothStartScanning = "ON_BLUETOOTH_START_SCANNING";
  static const onBluetoothStopScanning = "ON_BLUETOOTH_STOP_SCANNING";
  static const onBluetoothDeviceDetected =
      "ON_BLUETOOTH_DEVICE_DETECTED_CALLBACK";
  static const onBluetoothConnectionError = "ON_BLUETOOTH_CONNECTION_ERROR";
  static const onBluetoothConnected = "ON_BLUETOOTH_CONNECTED";
  static const onBluetoothDisconnected = "ON_BLUETOOTH_DISCONNECTED";
  static const onRequestPin = "ON_REQUEST_PIN";
  static const onRequestCard = "ON_REQUEST_CARD";
  static const onRequestBluetoothConnection = "ON_REQUEST_BLUETOOTH_CONNECTION";
  static const onTransactionError = "ON_TRANSACTION_ERROR";
  static const onProcessCardPayment = "ON_PROCESS_CARD_PAYMENT";
  static const onPINProvided = "ON_PIN_PROVIDED";
  static const disconnectDevice = "DISCONNECT_DEVICE";
  static const onSettingBankBox = "ON_SETTING_BANK_BOX";
  static const String onFinishedSettingBankBox = "ON_FINISH_SETTING_BANKBOX";
  static const String noDeviceDetectedAnymore = "NO_DEVICE_DETECTED_ANYMORE";
  static const cancelPinEntry = "CANCEL_PIN_ENTRY";
  static const String disconnectBluetoothDevice = "DISCONNECT_BLUETOOTH_DEVICE";
}

class RavenMPosEvent {
  final RavenMPosEventType eventType;
  final dynamic data;
  RavenMPosEvent({required this.eventType, required this.data});
}

enum RavenMPosEventType {
  error,
  alert,
  searchedDevices,
  scanning,
  stopScanning,
  connected,
  connectionErr,
  disconnected,
  card,
  pin,
  deviceNotDetectedAnymore,
  settingBankBox,
  settingCompleted,
  processPayment,
  transactionError
}

enum PaymentType { card, checkBalance }
