import 'package:flutter/material.dart';
import 'package:mobile_pos/src/helpers/helper_functions.dart';
import 'package:mobile_pos/src/styles/ravenpay_textstyles.dart';

class RavenPayMoneyWidget extends StatelessWidget {
  final double fontSize;
  final Color? color;
  const RavenPayMoneyWidget({
    super.key,
    this.color,
    this.fontSize = 16,
    required this.amount,
  });
  final String amount;
  @override
  Widget build(BuildContext context) {
    return RichText(
        text: TextSpan(
            text: '₦',
            style: headling1.copyWith(
                fontFamily: 'Roboto',
                fontSize: fontSize,
                color: color,
                fontWeight: FontWeight.bold),
            children: [
          TextSpan(
              text: amount.toString().isEmpty
                  ? "0.00"
                  : formatAmount(double.tryParse(amount.toString()) ?? 0),
              style: headling1.copyWith(fontSize: fontSize, color: color))
        ]));
  }
}
